<template>
	<div class="col-md-6 col-sm-12">
		<div class="login-form">
			<FormValidator ref="authForm">
				<form @submit.prevent="onLogin">
					<div class="login-form__network-error" v-if="loginFormError">
					{{ loginFormError }}
					</div>
					<FieldValidator 
						name="email" 
						rules="required|email" 
						mode="lazy" 
						slim 
						v-slot="{ errors }"
					>
						<div class="form-group">
							<label>Email</label>
							<input 
								
								type="text" 
								class="form-control" 
								:class="{ 'is-invalid': errors.length > 0 }"
								placeholder="Email" 
								name="email"
								v-model="loginForm.email"
							/>
						
							<div 
								v-for="(error, key) in errors" 
								:key="`email-${key}`" 
								class="invalid-feedback"
								v-show="errors"
							>
								{{ error }}
							</div>
						</div>
					</FieldValidator>
					<FieldValidator 
						v-if="choiceMove"
						name="userName" 
						rules="required|max:40|min:8|regex:^[а-яА-Я_ ]+$" 
						mode="lazy" 
						slim 
						v-slot="{ errors }"
					>
						<div class="form-group">
							<label>ФИО</label>
							<input 
								
								type="text" 
								class="form-control" 
								:class="{ 'is-invalid': errors.length > 0 }"
								placeholder="ФИО" 
								name="userName"
								v-model="loginForm.userName"
							/>
						
							<div 
								v-for="(error, key) in errors" 
								:key="`userName-${key}`" 
								class="invalid-feedback"
								v-show="errors"
							>
								{{ error }}
							</div>
						</div>
					</FieldValidator>
					<FieldValidator 
						name="password" 
						rules="required|min:8" 
						mode="lazy" 
						slim 
						v-slot="{ errors }"
					>
						<div class="form-group">
							<label>Пароль</label>
							<input 
								type="password" 
								class="form-control" 
								:class="{ 'is-invalid': errors.length > 0 }"
								placeholder="Пароль" 
								name="password"
								v-model="loginForm.password"
							/>
						
							<div 
								v-for="(error, key) in errors" 
								:key="`password-${key}`" 
								v-show="errors"
								class="invalid-feedback"
							>
								{{ error }}
							</div>
						</div>
					</FieldValidator>
					<div class="checkBoxRegistration">
						<input type="checkbox" value='регистрация' v-model="choiceMove">Регистрация
					</div>
					<button type="submit" v-if="choiceMove" class="btn btn-warning">регистрация</button>
					<button type="submit" v-if="!choiceMove" class="btn btn-danger">Вход</button>
					
				</form>
			</FormValidator>
		</div>
	</div>
</template>

<script>
//Mixin с методом validationMethod() для валидации формы
import { mixinValidation } from '@/mixins/validation.mixin'
//плагин для валидации(Vee validate)
import { ValidationObserver, ValidationProvider } from 'vee-validate'

export default {
	name: 'LoginPage', // страница авторизации и регистрации
	mixins: [mixinValidation],
	auth: false, //исключаю от защиты роута на этой странице
	layout: 'unauthorized', 
	components: {
		//объявляю компоненты vee validate
		FormValidator: ValidationObserver,
		FieldValidator: ValidationProvider
	},
	data: () => ({
		loginForm: {
			userName: '',
			email: '',
			password: '',
			
		},
		loginFormError: null,
		choiceMove: Boolean
	}),
	methods: {
		//вход пользователем
		async onLogin() {
			const isCorrect = await this.$refs.authForm.validate()
			if(isCorrect&&!this.choiceMove) {

				try {
					const response = await this.$auth.loginWith('local', {
						data: this.loginForm,
					})
					this.$router.push({ 
						path: '/user', 
						query: {
							email: response.data.email
						} 
					})

				} catch (err) {
					console.log(err.response)
					this.loginFormError = err.response.data.message
				}

			}
			//создание нового пользователя
			else if(isCorrect&&this.choiceMove&&this.validationMethod()){
				try {
					alert('Пользователь зарегистрирован!')
					await this.$axios.post('/auth/signUp', this.loginForm)
					const response = await this.$auth.loginWith('local', {
						data: this.loginForm,
					})
					this.$router.push({ 
						path: '/user', 
						query: {
							email: response.data.email
						} 
					})
				} catch (err) {
					console.log(err.response)
					this.loginFormError = err.response.data.message
				}
			}
		}
	},
}
</script>

<style scoped>
.login-form__network-error{
	border-radius: 6px;
	padding: 10px;
	color: #8f0000;
	background: #eba0a0
}
.checkBoxRegistration{
	margin-bottom: 10px;
}
</style>